//+------------------------------------------------------------------+
//|                                 60_Second_HH/LL_Break.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

//V1.2
//Change candle break BB Line instead of Close outside

   #property copyright   "Copyright  2014 // BO_Tutor_Germany // Facebook.de/BO_Tutor"
   #property description "Follows the 60 Seconds Strategy idea and initial coding from kmdodani & airquest on BOE. http://tinyurl.com/ng7emzm"



#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_width1 2
#property indicator_color2 White
#property indicator_width2 2






int    MagicNo = 100;
extern int ADXbars = 4;
extern int    ArrowsUpCode       = 217;
extern int    ArrowsDnCode       = 218;
extern color EntryLineColor = White;
bool    AlertOnCurrent    =  true;



bool show_arrow = true;
bool enable_alert = true;

double arr_up[];
double arr_dn[];
double b4plusdi,nowplusdi,b4minusdi,nowminusdi;
double     myPoint;
int        myDigits;

int gAlertShift = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   myPoint     =  MarketInfo(Symbol(),MODE_POINT);
   myDigits    =  MarketInfo(Symbol(),MODE_DIGITS);
   if(myDigits==3 || myDigits==5)
   {
      myPoint     =  myPoint  *  10;
      myDigits    =  myDigits -1;
   }    
  
   if(show_arrow)
   {
//---- indicators
      SetIndexBuffer(0, arr_up);
      SetIndexBuffer(1, arr_dn);  
//---- drawing settings
      SetIndexStyle(0, DRAW_ARROW);
      SetIndexArrow(0, ArrowsUpCode);
      SetIndexStyle(1, DRAW_ARROW);
      SetIndexArrow(1, ArrowsDnCode);
      
      SetIndexLabel(0, "BUY Signal");
      SetIndexLabel(1, "SELL Signal");

      IndicatorDigits(Digits);
   }
   
   gAlertShift = 1;
   if(AlertOnCurrent) gAlertShift = 0;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete("EntryLine11");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{

   int    counted_bars=IndicatorCounted();
   //----   
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   
   int j;
   for(int i=limit; i>=0; i--)
   {
      arr_up[i] = EMPTY_VALUE; arr_dn[i] = EMPTY_VALUE;      
      
      j=i;
      double var1 = 0;
      double var2 = 0;
      for (j = i; j <= i + 9; j++) var2 += MathAbs(High[j] - Low[j]);
      var1 = var2 / 10.0;
      
     	b4plusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI,i+1);
	nowplusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_PLUSDI,i);
	b4minusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,i+1);
	nowminusdi=iADX(NULL,0,ADXbars,PRICE_CLOSE,MODE_MINUSDI,i); 
         double BandsUp = iBands(NULL,0,1,2,0,0,1,i+2);
         double BandsDn = iBands(NULL,0,1,2,0,0,2,i+2);


      
      if(

           ((Low[i+2]  <= BandsDn && Low[i+2]  == Low[i+1]  && Close[i+1] >= Open[i+2]-MagicNo*Point /*&& Close[i+1] <= High[i+2]*/ && Close[i] >= High[i+1] && (b4plusdi<b4minusdi && nowplusdi>nowminusdi) && Close[i+1]>=Open[i+1]) ||
               (Low[i+2]  <= BandsDn && High[i+2] == High[i+1] && Close[i] >= High[i+1]&& (b4plusdi<b4minusdi && nowplusdi>nowminusdi) && Close[i+1]>=Open[i+1]))      
        )
      {
         arr_up[i]=iLow(Symbol(),0,i) - (var1/2);
         DrawLine("EntryLine11",iHigh(Symbol(),0,i+1),EntryLineColor);      
      }
      else if(
        ( (High[i+2] >= BandsUp && High[i+2] == High[i+1] && Close[i+1] <= Open[i+2]+MagicNo*Point /*&& Close[i+1] >= Low[i+2]*/  && Close[i] <= Low[i+1] && (b4plusdi>b4minusdi && nowplusdi<nowminusdi) && Close[i+1]<=Open[i+1])||  
         (High[i+2] >= BandsUp && Low[i+2]  == Low[i+1]  && Close[i] <= Low[i+1] && (b4plusdi>b4minusdi && nowplusdi<nowminusdi) && Close[i+1]<=Open[i+1]) ) 
        )
      {
         arr_dn[i]=iHigh(Symbol(),0,i) + (var1/2);      
         DrawLine("EntryLine11",iLow(Symbol(),0,i+1),EntryLineColor);      
      }        
   }
   
   static datetime dtlboai11;
   
   if(dtlboai11!=iTime(Symbol(),0,0))
   {
      string stralert;
      if(arr_up[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Long Signal Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName();
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
      else if(arr_dn[gAlertShift]!=EMPTY_VALUE)
      {
         stralert="Short Signal Alert "+ Symbol()+ " " + strtf(Period()) + " Date & Time: " + TimeToStr(TimeCurrent(),TIME_DATE)+" "+TimeToStr(TimeCurrent(),TIME_MINUTES) + " - " + WindowExpertName();
         Alert(stralert);
         dtlboai11=iTime(Symbol(),0,0);
      }
   }
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

string strtf(int tf)
{
   switch(tf)
   {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN1");
      default:return("Unknown timeframe");
   }
}


void DrawLine(string sName, double dPrice,color cLineClr=CLR_NONE)
{
    int iWidth=1;
    string sObjName = sName;

    if(ObjectFind(sObjName) == -1){
        // create object 
        ObjectCreate(sObjName,OBJ_HLINE, 0, 0,0);
    }

    ObjectSet(sObjName,OBJPROP_PRICE1,dPrice);
    ObjectSet(sObjName, OBJPROP_COLOR, cLineClr);
    ObjectSet(sObjName, OBJPROP_WIDTH, iWidth);
    ObjectSet(sObjName, OBJPROP_STYLE, STYLE_DOT);
}
